/*
 * Copyright (c) 2025. Sergey S. Chernov - All Rights Reserved
 *
 *  You may use, distribute and modify this code under the
 * terms of the private license, which you must obtain from the author
 *
 * To obtain the license, contact the author: https://t.me/real_sergeych or email to
 * real dot sergeych at gmail.
 */

package net.sergeych.kiloparsec.adapter

import kotlinx.coroutines.channels.Channel

/**
 * Transport device for inet protocol family with graceful shutdown on [close]
 */
@Suppress("unused")
class InetTransportDevice(
    inputChannel: Channel<UByteArray>,
    outputChannel: Channel<UByteArray>,
    val remoteAddress: NetworkAddress,
    doClose: (suspend ()->Unit)? = null,
    doFlush: (suspend ()->Unit)? = null,
) : ProxyDevice(inputChannel, outputChannel, doClose, doFlush) {
    override fun toString(): String = "@$remoteAddress"
}