/*
 * Copyright (c) 2025. Sergey S. Chernov - All Rights Reserved
 *
 *  You may use, distribute and modify this code under the
 * terms of the private license, which you must obtain from the author
 *
 * To obtain the license, contact the author: https://t.me/real_sergeych or email to
 * real dot sergeych at gmail.
 */

package net.sergeych.kiloparsec.adapter

import io.ktor.network.sockets.*

/**
 * The interface for common UDP connector shared by UDP components
 */
internal interface UdpConnector {
    /**
     * Called when client connection is done so the provider could free resources
     */
    suspend fun disconnectClient(address: SocketAddress)

    /**
     * Send a block from a proper UDP socket
     */
    suspend fun sendBlock(block: UdpBlock, toAddress: SocketAddress)
}